#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/io.h>
#include <unistd.h>
#include <fcntl.h>
#include <RCCE.h>
#include <RCCE_lib.h>

#define N 10000000
#define NS 1000000000

//
//       THIS CODE DOES _NOT_ WORK WITH THE OPENMP RCCE EMULATOR!
//
#ifdef _OPENMP
#warning THIS CODE DOES _NOT_ WORK WITH THE OPENMP RCCE EMULATOR!
#endif
//
//

typedef struct {
	int counter;
	int initializer;
} atomic_increg_t;

volatile atomic_increg_t *incregs = NULL;

int RCCE_APP(int argc, char **argv)
{
	int id, num, ncm_fd, pagesize, i, j, nbr_air;
	double timer;
	off_t aligned_addr, page_off;

	/* INIT: RCCE environment */

	RCCE_init(&argc, &argv);

	id = RCCE_ue();
	num = RCCE_num_ues();

	nbr_air = atoi(argv[1]);

	if(iopl(3)) {
		printf("Couldn't change I/O privilege level\n");
		exit(-1);
	}

	/* INIT: Set up atomic increment registers */
	pagesize = getpagesize();
	aligned_addr = 0xf900E000 & (~(pagesize-1));
	page_off = 0xf900E000 ^ aligned_addr;


	ncm_fd = open("/dev/rckncm", O_RDWR | O_SYNC);
	if (ncm_fd < 0) {
		printf("Opening /dev/rckncm failed: %s\n", strerror(errno));
		exit(-1);
	}

	incregs = (volatile atomic_increg_t *) mmap(NULL, pagesize, PROT_WRITE | PROT_READ,
			MAP_SHARED, ncm_fd, aligned_addr);
	if (incregs == MAP_FAILED) {
		printf("Couldn't map atomic increment registers "
			"into virtual address space\n");
		exit(-1);
	}
	incregs += page_off;

	if(id == 0)
		for(j = 0; j < nbr_air; j++)
			incregs[j].initializer = 0;

	RCCE_barrier(&RCCE_COMM_WORLD);
//	asm volatile("cli");
	timer = RCCE_wtime();
	
	for (j = 0; j < nbr_air; j++){
		for (i = 0; i < N; i++) {
			incregs[j].counter & 0x01;
		}
	}
	
	
	timer = RCCE_wtime() - timer;
//	asm volatile("sti");

	RCCE_barrier(&RCCE_COMM_WORLD);
	if(id == 0){
		for(j = 0; j < nbr_air; j++){
			if(incregs[j].initializer != N * RCCE_COMM_WORLD.size){
				printf("Counter didn't count correctly\n"				
					"Was %i, expected %i at Air:%i\n", incregs[j].initializer, N * RCCE_COMM_WORLD.size, j);

			}
		}
	}

	printf("Time: %f\tID: %d\n", timer, id);
	fflush(stdout);

	RCCE_barrier(&RCCE_COMM_WORLD);
	RCCE_finalize();

	return 0;
}
