#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/io.h>

#include "RCCE.h"
#include "iRCCE.h"

#define N 100
#define NS 1000000000

#define NUM 3

#define LOCK 0

#if LOCK
# define INTLOCK asm volatile("cli");
# define INTUNLOCK asm volatile("sti");
#else
# define INTLOCK do {} while(0)
# define INTUNLOCK do {} while(0)
#endif

int RCCE_APP(int argc, char **argv)
{
	int i, id, num, j, k;
	volatile double *timer[NUM];
	double tmp_timer;

	volatile int *test;

	/* INIT: (i)RCCE environment */
	RCCE_init(&argc, &argv);
	iRCCE_init();
	num = RCCE_num_ues();
	id = RCCE_ue();

#if LOCK
	if(iopl(3)) {
		printf("Couldn't change I/O privilege level\n");
		exit(-1);
	}
#endif

	for (i = 0; i < NUM; i++){
	  timer[i] = (volatile double*)RCCE_shmalloc(num * sizeof(double));
        }
	
        test = (volatile int*)RCCE_shmalloc(num * sizeof(int));
	
	RCCE_barrier(&RCCE_COMM_WORLD);
	if(id==0)
		for(i=0;i<num;i++)
			test[i]=0;
	RCCE_barrier(&RCCE_COMM_WORLD);

	for (j = 0; j < NUM; j++) {
		INTLOCK;
		tmp_timer = RCCE_wtime();
		switch(j) {
		case 0:
			for (i = 0; i < N; i++)
				RCCE_barrier(&RCCE_COMM_WORLD);
			break;
		case 1:
			for (i = 0; i < N; i++)
				iRCCE_barrier(&RCCE_COMM_WORLD);
				test[(j+id)%num] += 1;
			break;
		case 2:
			for (i = 0; i < N; i++);
				//iRCCE_backoff_barrier(&RCCE_COMM_WORLD);
			break;
		}
		timer[j][id] = RCCE_wtime() - tmp_timer;
		INTUNLOCK;
		RCCE_barrier(&RCCE_COMM_WORLD);
		if(id==0 && j==1) {
		  for(k=0;k<num;k++)
			printf("%d: %d \n",k,test[k]);
		  fflush(stdout);
		}
		RCCE_barrier(&RCCE_COMM_WORLD);
	}

	if (id == 0) {
		FILE *fd;
		char name[1024];
		snprintf(name, 1024, "/shared/yafb%i.txt", num);

		fd = fopen(name, "w");
		if (!fd) {
			printf("Couldn't open logfile\n");
			return -1;
		}
		fprintf(fd, "# id\t\tRCCE\t\tiRCCE\t\tiRCCE_backoff\n");
		for (i = 0; i < num; i++) {
			fprintf(fd, "%i", i);
			for (j = 0; j < NUM; j++)
				fprintf(fd, "\t\t%1.2f", timer[j][i] * (NS/N));;
			fprintf(fd, "\n");
		}
		fclose(fd);
	}

	//iRCCE_finalize();
	RCCE_finalize();

	return 0;
}
